Bug 187617 - Upgrade process is painful
Upgrade process is painful
Product: Fedora
Classification: Fedora
Component: postgresql (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Lane
David Lawrence
Depends On:
  Show dependency treegraph
Reported: 2006-04-01 17:11 EST by Daryll
Modified: 2013-07-02 23:09 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-05-06 11:44:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Daryll 2006-04-01 17:11:18 EST
I upgraded from FC3 to FC5 on a system that runs a Postgresql database. As you
know that means the database needs to be updated as well.

Unfortunetly, the OS install has already installed the new Postgres version.
That makes the upgrade process rediculously painful. The process seems to be:

look at /var/lib/pgsql/data/PG_VERSION to determine your current version
cp /usr/bin/pg_dumpall /usr/tmp (They recommend using the latest version of dumpall)
rpm -qa | grep postgresql to find all the postgres packages
rpm -e --nodeps all the postgres packages (temporarily breaking anything that
depended on postgresql)
Find a repository with the previous release of fedora
Download the latest postgres packages that match your version (from the base or
upgrades) Make sure you get all the packages you removed, since you get no help
with handling the dependencies
Install that version of postgres
/usr/tmp/pg_dumpall > postgres.dump
yum update to get back to the correct version of postgres
pg_restore < postgres.dump to get your data

That process is WAY too difficult and it took significant work to figure out
that was the right process in the first place. There must be a better way.

I read in the documentation that you were working on a way to have multiple
copies of postgresql installed at once. That would simplify the process
dramatically. Consider including an upgrade script in there as well.

Is there some reason that postgresql doesn't check the version and do a
pg_dumpall in the RPM preinstall script? That would save a huge amount of
headache and seems like a fairly safe operation. It doesn't have to do the whole
upgrade, but avoiding having the user reinstall the old package would be a huge

In fact, I'd argue that given what is required to do this upgrade you'd be
better off never upgrading to incompatible versions. Having a way to skip the
postgres upgrade until after the user has done the dump would be better.
Unfortunately, I don't think RPM has a way for a package's install scripts to
gracefully deny the package from being stalled.
Comment 1 Bug Zapper 2008-04-03 22:30:32 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 2 Bug Zapper 2008-05-06 11:44:21 EDT
This bug is open for a Fedora version that is no longer maintained and
will not be fixed by Fedora. Therefore we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen thus bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.